#include "StdAfx.h"
#include "saMP.h"

Observer::~Observer()
{
	POSITION it = m_SubjectList.GetHeadPosition();

	if (it != NULL)
	{
		m_SubjectList.GetAt(it)->DeleteObserver(this);

		while (it != m_SubjectList.GetTailPosition() )
		{
			m_SubjectList.GetNext(it);
			m_SubjectList.GetAt(it)->DeleteObserver(this);
		}
	}
}

/* -------------------- */
/* Observer::AddSubject */
/* -------------------- */
void Observer::AddSubject(Subject* _Sub)
{
	m_SubjectList.AddTail(_Sub);
}

/* ----------------------- */
/* Observer::DeleteSubject */
/* ----------------------- */
void Observer::DeleteSubject(Subject* _Sub)
{
	m_SubjectList.RemoveAt( m_SubjectList.Find(_Sub) );
}

/* ---------------- */
/* Observer::Update */
/* ---------------- */
void Observer::Update()
{
}
