#pragma once
#include "afxwin.h"

class CsaMPDlg;


// Bote de dialogue CPlayListManagDlg

class CPlayListManagDlg : public CDialog
{
	DECLARE_DYNAMIC(CPlayListManagDlg)

private:
	CsaMPDlg *m_Parent;
	PlayList *m_pPlayList;
	CList<Music*, Music*> *m_pMusicList;

public:
	CPlayListManagDlg(CWnd* pParent = NULL);   // constructeur standard
	virtual ~CPlayListManagDlg();

// Donnes de bote de dialogue
	enum { IDD = IDD_DIALOG1 };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // Prise en charge de DDX/DDV

	DECLARE_MESSAGE_MAP()
private:
	CListBox m_ListBox;
public:
	virtual BOOL OnInitDialog();

private:
	void DisplayList();
	POSITION GetCurrentPosition();

public:
	void SetPlayList(PlayList &_PlayList);
	void SetParent(CsaMPDlg *_Parent);

	afx_msg void OnBnClickedButtonDelete();
	afx_msg void OnLbnDblclkList1();
	afx_msg void OnBnClickedButtonSave();
	afx_msg void OnBnClickedButtonLoad();
	afx_msg void OnBnClickedButtonUp();
	afx_msg void OnBnClickedButtonDown();
	afx_msg void OnBnClickedButtonClear();
};
