// saMPDlg.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "saMP.h"
#include "saMPDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// bote de dialogue CsaMPDlg




CsaMPDlg::CsaMPDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CsaMPDlg::IDD, pParent),
	m_CurrentAction(None)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CsaMPDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CsaMPDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_TIMER()
END_MESSAGE_MAP()


// gestionnaires de messages pour CsaMPDlg

BOOL CsaMPDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Dfinir l'icne de cette bote de dialogue. L'infrastructure effectue cela automatiquement
	//  lorsque la fentre principale de l'application n'est pas une bote de dialogue
	SetIcon(m_hIcon, TRUE);			// Dfinir une grande icne
	SetIcon(m_hIcon, FALSE);		// Dfinir une petite icne

	// TODO : ajoutez ici une initialisation supplmentaire
	// Initialisation des positions des boutons
	InitButtonRect();

	SetTimer(1, 100, NULL);

	return TRUE;  // retourne TRUE, sauf si vous avez dfini le focus sur un contrle
}

// Si vous ajoutez un bouton Rduire  votre bote de dialogue, vous devez utiliser le code ci-dessous
//  pour dessiner l'icne. Pour les applications MFC utilisant le modle Document/Vue,
//  cela est fait automatiquement par l'infrastructure.

void CsaMPDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // contexte de priphrique pour la peinture

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Centrer l'icne dans le rectangle client
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Dessiner l'icne
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Le systme appelle cette fonction pour obtenir le curseur  afficher lorsque l'utilisateur fait glisser
//  la fentre rduite.
HCURSOR CsaMPDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


/* ----------------------- */
/* CsaMPDlg::OnLButtonDown */
/* ----------------------- */
void CsaMPDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO : ajoutez ici le code de votre gestionnaire de messages et/ou les paramtres par dfaut des appels
	if (m_CurrentAction != None)
	{
		LaunchAction();
	}

	CDialog::OnLButtonDown(nFlags, point);
}

/* ------------------------ */
/* CsaMPDlg::InitButtonRect */
/* ------------------------ */
void CsaMPDlg::InitButtonRect()
{
	m_BtnList[Play].SetRect(300, 355, 370, 435);
	m_BtnList[Stop].SetRect(130, 365, 195, 425);
	m_BtnList[Next].SetRect(390, 210, 460, 290);
	m_BtnList[Previous].SetRect(40, 210, 105, 290);
	m_BtnList[Random].SetRect(70, 300, 135, 370);
	m_BtnList[Repeat].SetRect(365, 305, 430, 370);
	m_BtnList[VolumeUp].SetRect(210, 40, 290, 110);
	m_BtnList[VolumeDown].SetRect(210, 390, 290, 460);
	m_BtnList[AddMusic].SetRect(60, 125, 135, 205);
	m_BtnList[Load].SetRect(135, 65, 205, 140);
	m_BtnList[Save].SetRect(300, 65, 365, 140);
	m_BtnList[EditPlayList].SetRect(365, 130, 435, 205);
}

/* --------------------------- */
/* CsaMPDlg::TestMousePosition */
/* --------------------------- */
void CsaMPDlg::TestMousePosition(const CPoint& _Point)
{
	if ( m_BtnList[Play].PtInRect(_Point) )
	{
		m_CurrentAction = Play;
	}
	else if ( m_BtnList[Stop].PtInRect(_Point) )
	{
		m_CurrentAction = Stop;
	}
	else if ( m_BtnList[Next].PtInRect(_Point) )
	{
		m_CurrentAction = Next;
	}
	else if ( m_BtnList[Previous].PtInRect(_Point) )
	{
		m_CurrentAction = Previous;
	}
	else if ( m_BtnList[Random].PtInRect(_Point) )
	{
		m_CurrentAction = Random;
	}
	else if ( m_BtnList[Repeat].PtInRect(_Point) )
	{
		m_CurrentAction = Repeat;
	}
	else if ( m_BtnList[VolumeUp].PtInRect(_Point) )
	{
		m_CurrentAction = VolumeUp;
	}
	else if ( m_BtnList[VolumeDown].PtInRect(_Point) )
	{
		m_CurrentAction = VolumeDown;
	}
	else if ( m_BtnList[AddMusic].PtInRect(_Point) )
	{
		m_CurrentAction = AddMusic;
	}
	else if ( m_BtnList[Load].PtInRect(_Point) )
	{
		m_CurrentAction = Load;
	}
	else if ( m_BtnList[Save].PtInRect(_Point) )
	{
		m_CurrentAction = Save;
	}
	else if ( m_BtnList[EditPlayList].PtInRect(_Point) )
	{
		m_CurrentAction = EditPlayList;
	}
	else
	{
		m_CurrentAction = None;
	}
}

/* --------------------- */
/* CsaMPDlg::OnMouseMove */
/* --------------------- */
void CsaMPDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO : ajoutez ici le code de votre gestionnaire de messages et/ou les paramtres par dfaut des appels
	TestMousePosition(point);

	CDialog::OnMouseMove(nFlags, point);
}

/* ---------------------- */
/* CsaMPDlg::LaunchAction */
/* ---------------------- */
void CsaMPDlg::LaunchAction()
{
	switch(m_CurrentAction)
	{
	case Play:
		PlayMusic();
		break;
	case Stop:
		StopMusic();
		break;
	case Next:
		m_PlayList.Next(true);
		break;
	case Previous:
		m_PlayList.Previous();
		break;
	case Repeat:
		AudioConfig::Get().Repeat();
		break;
	case Random:
		AudioConfig::Get().Random();
		break;
	case VolumeUp:
		AudioConfig::Get().VolumeUp();
		break;
	case VolumeDown:
		AudioConfig::Get().VolumeDown();
		break;
	case AddMusic:
		LoadMusic();
		break;
	case Load:
		LoadPlayList();
		break;
	case Save:
		SavePlayList();
		break;
	case EditPlayList:
		LaunchPlayListManager();
		break;
	}
}

/* ------------------- */
/* CsaMPDlg::LoadMusic */
/* ------------------- */
void CsaMPDlg::LoadMusic()
{
	// Lancement d'une boite de dialogue pour chargement
	CString FileName = LoadFileDialog(true);
	if ( !( FileName.IsEmpty() ) )
	{
		if ( ! (m_PlayList.AddMusic(FileName) ) )
		{
			CString Error("Error - Music has not been loaded ! Path : ");
			Error += FileName;
			MessageBox(Error);
		}
	}
}

/* ------------------------ */
/* CsaMPDlg::LoadFileDialog */
/* ------------------------ */
CString CsaMPDlg::LoadFileDialog(bool _OpenMode, bool _LoadMusic)
{
	CString FileName("");
	// Lancement d'une boite de dialogue pour chargement
	CFileDialog FileDlg(_OpenMode);

	if (FileDlg.DoModal() == IDOK)
	{
		FileName = FileDlg.GetPathName();
	}
	return FileName;
}

/* ------------------------------- */
/* CsaMPDlg::LaunchPlayListManager */
/* ------------------------------- */
void CsaMPDlg::LaunchPlayListManager()
{
	CPlayListManagDlg PLManager;
	PLManager.SetPlayList(m_PlayList);
	PLManager.SetParent(this);
	PLManager.DoModal();
}

/* ------------------- */
/* CsaMPDlg::PlayMusic */
/* ------------------- */
void CsaMPDlg::PlayMusic()
{
	Music *Current = m_PlayList.GetCurrent();

	if (Current != NULL)
	{
		Current->Play();
	}
}

/* ------------------- */
/* CsaMPDlg::StopMusic */
/* ------------------- */
void CsaMPDlg::StopMusic()
{
	Music *Current = m_PlayList.GetCurrent();

	if (Current != NULL)
	{
		Current->Stop();
	}
}

/* ----------------- */
/* CsaMPDlg::OnTimer */
/* ----------------- */
void CsaMPDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO : ajoutez ici le code de votre gestionnaire de messages et/ou les paramtres par dfaut des appels
	m_PlayList.Manage();

	CDialog::OnTimer(nIDEvent);
}

/* ---------------------- */
/* CsaMPDlg::SavePlayList */
/* ---------------------- */
void CsaMPDlg::SavePlayList()
{
	CString FileName = LoadFileDialog(false, false);
	CFile File;
	if (File.Open(FileName, CFile::modeWrite|CFile::modeCreate))
	{
		CArchive Arch(&File, CArchive::store);
		m_PlayList.Serialize(Arch);
	}
}

/* ---------------------- */
/* CsaMPDlg::LoadPlayList */
/* ---------------------- */
void CsaMPDlg::LoadPlayList()
{
	CString FileName = LoadFileDialog(true, false);
	CFile File;
	if (File.Open(FileName, CFile::modeRead))
	{
		CArchive Arch(&File, CArchive::load);
		m_PlayList.Serialize(Arch);
	}
}
